#!/bin/bash
 
REPORTS=/usr/local/httpd/htdocs/squint
SQUINT="nice /usr/local/bin/squint.pl"
SELF="$0"
WEEKS=52
REVISION='$Id: squint.cron.sh,v 1.6 2002/06/27 09:49:12 andrewm Exp $'
umask 002
 
# Create index.html file
function doupdateindex()
{
mkdir -p $REPORTS
# write the index.html file
{
echo '<HTML>
<HEAD>
<TITLE>Squint reports</TITLE>
</HEAD>
<BODY>
<H1>Squint reports</H1>';
echo "<H2>Daily report</H2>
<A href=daily/index.html>Daily (`cat $REPORTS/daily/range.txt`)</A><BR>";

echo "<H2>Weekly reports</H2>";
for ((NUM=0; NUM<7; NUM++)) ; do
	if [ -f $REPORTS/weekly$NUM/range.txt ] ; then
	echo "<A href=weekly$NUM/index.html>`cat $REPORTS/weekly$NUM/range.txt`</A><BR>"
	fi
done

echo "<H2>Monthly reports</H2>";
for ((NUM=0; NUM<7; NUM++)) ; do
	if [ -f $REPORTS/monthly$NUM/range.txt ] ; then
	echo "<A href=monthly$NUM/index.html>`cat $REPORTS/monthly$NUM/range.txt`</A><BR>"
	fi
done

echo "<HR><FONT size=-4>Generated at `date` by $HOSTNAME with $REVISION
</FONT></BODY></HTML>";

} > $REPORTS/index.html

grep -q "squint" /etc/crontab ||
echo "# squint squid reports
00 01 * * Monday  root /usr/local/bin/squint.cron.sh weekly
00 01 * 1 *    root /usr/local/bin/squint.cron.sh monthly
00 01 * * *    root /usr/local/bin/squint.cron.sh daily" >> /etc/crontab && killall -1 cron

} # end of doupdateindex function

function doreport()
{
        # doreport DESTINATION FROMTIME-WHEN
        DAYS="$1"
        FROMTIME="$2"
	TOTIME="$3"
	DESTDIR="$4"
	STARTTIME=`date +%s -d "$FROMTIME"`
	ENDTIME=`date +%s -d "$TOTIME"`
	[ -d $DESTDIR ] && rm -r $DESTDIR
	mkdir -p $DESTDIR
	find /var/squid/logs -name "access.log-*.gz" -mtime -$DAYS -exec gunzip {} \;
	{
	find /var/squid/logs -name "access.log-*" -mtime -$DAYS | sort
	echo "/var/squid/logs/access.log"
	} | xargs cat | $SQUINT $DESTDIR $STARTTIME $ENDTIME
	doupdateindex
}

case "$1" in
	doupdateindex)
		doupdateindex
		;;
	regen)
		for report in daily weekly0 weekly1 weekly2 weekly3 weekly4 weekly5 weekly6 ; do
			$0 $report 
		done
		;;
	daily)
		# week-so-far report
		doreport 7 "last monday" "now" $REPORTS/daily
		;;

	weekly0) doreport 15 "last monday 1 weeks ago" "last monday 0 weeks ago" $REPORTS/weekly0 ;;
	weekly1) doreport 21 "last monday 2 weeks ago" "last monday 1 weeks ago" $REPORTS/weekly1 ;;
	weekly2) doreport 28 "last monday 3 weeks ago" "last monday 2 weeks ago" $REPORTS/weekly2 ;;
	weekly3) doreport 35 "last monday 4 weeks ago" "last monday 3 weeks ago" $REPORTS/weekly3 ;;
	weekly4) doreport 42 "last monday 5 weeks ago" "last monday 4 weeks ago" $REPORTS/weekly4 ;;
	weekly5) doreport 49 "last monday 6 weeks ago" "last monday 5 weeks ago" $REPORTS/weekly5 ;;
	weekly6) doreport 56 "last monday 7 weeks ago" "last monday 6 weeks ago" $REPORTS/weekly6 ;;

	weekly)
		rm -r $REPORTS/weekly6
		mv 2>/dev/null -f $REPORTS/weekly5 $REPORTS/weekly6
		mv 2>/dev/null -f $REPORTS/weekly4 $REPORTS/weekly5
		mv 2>/dev/null -f $REPORTS/weekly3 $REPORTS/weekly4
		mv 2>/dev/null -f $REPORTS/weekly2 $REPORTS/weekly3
		mv 2>/dev/null -f $REPORTS/weekly1 $REPORTS/weekly2
		mv 2>/dev/null -f $REPORTS/weekly0 $REPORTS/weekly1
		doreport 8 "1 week ago 00:00" "00:00" $REPORTS/weekly0
		;;
	monthly)
		rm -r $REPORTS/monthly6
		mv 2>/dev/null -f $REPORTS/monthly5 $REPORTS/monthly6
		mv 2>/dev/null -f $REPORTS/monthly4 $REPORTS/monthly5
		mv 2>/dev/null -f $REPORTS/monthly3 $REPORTS/monthly4
		mv 2>/dev/null -f $REPORTS/monthly2 $REPORTS/monthly3
		mv 2>/dev/null -f $REPORTS/monthly1 $REPORTS/monthly2
		mv 2>/dev/null -f $REPORTS/monthly0 $REPORTS/monthly1
		doreport 32 "1 month ago 00:00" "00:00" $REPORTS/monthly0
		;;
	init)
		doupdateindex
		;;
	all)
		$0 daily
		$0 weekly
		$0 monthly
		;;
	*)	
		echo "Usage: $0 [daily|weekly|monthly|all]"
		;;
esac
 
exit 0

